//#version 120 //attribute
precision mediump float;
varying vec2 aCoordinate;
varying vec2 aFBOTextureCoord;//FBO纹理坐标

uniform sampler2D fTextureOrg;
uniform sampler2D fTextureLine;
uniform int useAutoProgress;
uniform int isManhe;
uniform float autoProgress;//进度 0-1;

void main() {
    gl_FragColor = texture2D(fTextureLine, aCoordinate);
    if (aCoordinate.x <= 0.001 || aCoordinate.y<=0.001 || aCoordinate.x >= 0.999 || aCoordinate.y >=0.999){
        gl_FragColor = vec4(1, 1, 1, 1);
//        gl_FragColor = vec4(0, 0, 0, 1);
    } else {
        if (isManhe == 1){
            if (gl_FragColor.a > 0.0){
                gl_FragColor = vec4(1, 1, 1, gl_FragColor.a);
            }
        } else {
            if (gl_FragColor.a >0.0){
                vec4 base = texture2D(fTextureOrg, aCoordinate);
                gl_FragColor = vec4(base.r, base.g, base.b, gl_FragColor.a);
            }
        }
    }

    if (useAutoProgress == 1){
        if (aCoordinate.y <= 0.01 && aCoordinate.x <= autoProgress*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), aCoordinate.x*0.25);
        }
        if (aCoordinate.x >= 0.99 && aCoordinate.y <= (autoProgress-0.25)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.25+aCoordinate.y*0.25);
        }
        if (aCoordinate.y >= 0.99 && aCoordinate.x >= 1.0-(autoProgress-0.5)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.5+(1.0-aCoordinate.x)*0.25);
        }
        if (aCoordinate.x <= 0.01 && aCoordinate.y >= 1.0-(autoProgress-0.75)*4.0){
            gl_FragColor = mix(vec4(0.953, 0.357, 0.502, 1), vec4(0.490, 0.278, 1, 1), 0.75+(1.0-aCoordinate.y)*0.25);
        }
    }
}

