precision mediump float;

varying vec3 v_Color;
varying float v_ElapsedTime;
varying float v_ParticleLifeTime;
varying float v_ParticleAngle;

uniform sampler2D u_TextureUnit;

//每次移动的角度
const float DEGREE = 3.0;
//gl_PointCoord 点模式下的 点的内部坐标
void main(){
    float f = (v_ParticleLifeTime - v_ElapsedTime);//剩余时间
    if (f< 0.0){
        discard;
    } else {
        //        //计算斜边长度
        vec2 temp = gl_PointCoord;
        float hLine = distance(vec2(0.5, 0.5), temp);
        //计算斜边的旋转度数
        float aDegree = 0.0;
        if (v_ParticleAngle > 0.0){
            aDegree = v_ParticleAngle + DEGREE * v_ElapsedTime + atan(temp.y - 0.5, temp.x - 0.5);
        } else {
            aDegree = v_ParticleAngle - DEGREE * v_ElapsedTime + atan(temp.y - 0.5, temp.x - 0.5);
        }

        //通过角度来计算x ，y轴坐标
        temp.x = hLine * cos(aDegree);
        temp.y = hLine * sin(aDegree);
        //将坐标转换为纹理坐标
        temp.x = temp.x + 0.5;
        temp.y = temp.y + 0.5;
        if (temp.x > 1.0){
            temp.x = 1.0;
        }
        if (temp.y > 1.0){
            temp.y = 1.0;
        }
        if (temp.x < 0.0){
            temp.x =  0.0;
        }
        if (temp.y < 0.0){
            temp.y =  0.0;
        }
        if (f<v_ParticleLifeTime*0.3){ //五分之一时候渐变消失
            gl_FragColor = vec4(v_Color.r, v_Color.g, v_Color.b, f/(v_ParticleLifeTime*0.3)*texture2D(u_TextureUnit, temp).a);
        } else {
            gl_FragColor = vec4(v_Color.r, v_Color.g, v_Color.b, texture2D(u_TextureUnit, temp).a);
        }
    }
    //    gl_FragColor = vec4(1.0,0,0,1.0);
    //    gl_FragColor = vec4(v_Color / v_ElapsedTime, 1.0) * texture2D(u_TextureUnit, gl_PointCoord);

    //画圆
    //    float xDistance = 0.5 - gl_PointCoord.x;
    //    float yDistance = 0.5 - gl_PointCoord.y;
    //    float distamceFromCenter = sqrt(xDistance*xDistance+yDistance*yDistance);
    //    if (distamceFromCenter >0.5){
    //        discard;
    //    } else {
    //        gl_FragColor = vec4(v_Color / v_ElapsedTime, 1.0);
    //    }
}


//#version 300 es
//precision mediump float;
//in vec2 v_texCoord;
//layout(location = 0) out vec4 outColor;
//uniform sampler2D s_TextureMap;
//void main(){
//    outColor = texture(s_TextureMap,v_texCoord);
//}

//#version 300 es
//precision mediump float;
//out vec4 fragColor;
//void main()
//{
//    fragColor = vec4 ( 1.0, 0.0, 0.0, 1.0 );  //填充三角形区域为红色
//}
